package com.intershop.sellside.rest.mycoupon.v1.internal.modules;

import java.util.Collection;
import java.util.function.Function;

import com.google.inject.AbstractModule;
import com.google.inject.TypeLiteral;
import com.intershop.sellside.rest.common.v1.capi.mapper.CollectionFunction;
import com.intershop.sellside.rest.mycoupon.v1.capi.resourceobject.mycoupon.MyCouponRO;
import com.intershop.sellside.rest.mycoupon.v1.internal.mapper.mycoupon.MyCouponROMapper;
import com.intershop.support.component.mycoupon.capi.MyCouponBO;

public class AppSfRestMyCouponMapperModule extends AbstractModule
{

    @Override
    protected void configure()
    {
        // common
        bind(new TypeLiteral<Function<MyCouponBO, MyCouponRO>>() {}).to(MyCouponROMapper.class);
        bind(new TypeLiteral<Function<Collection<MyCouponBO>, Collection<MyCouponRO>>>() {})
            .to(new TypeLiteral<CollectionFunction<MyCouponBO, MyCouponRO>>() {});
    }

}
