package com.intershop.sellside.rest.mycoupon.v1.internal.resource;

import javax.ws.rs.container.ResourceContext;

import com.intershop.component.rest.capi.resource.RestResource;
import com.intershop.component.rest.capi.resource.RootResource;
import com.intershop.component.rest.capi.resource.SubResourceProvider;
import com.intershop.sellside.rest.mycoupon.v1.capi.MyCouponConstantsREST;
import com.intershop.sellside.rest.mycoupon.v1.capi.resource.mycoupon.MyCouponListResource;

/**
 * {@link SubResourceProvider} for {@link MyCouponListResource}.
 */
public class MyCouponListResourceProvider implements SubResourceProvider
{
    public static final String MY_COUPON_RESOURCE_ACL_PATH = "resources/support_app_sf_rest_mycoupon/rest/mycoupon-acl.properties";

    @Override
    public Object getSubResource(RestResource parent, ResourceContext rc, String subResourceName)
    {
        if (isApplicable("support_app_sf_rest_mycoupon") && MyCouponConstantsREST.RESOURCE_PATH_MY_COUPON_V1.equals(subResourceName))
        {
            parent.getRootResource().addACLRuleIfSupported(MY_COUPON_RESOURCE_ACL_PATH);
            Object resource = getSubResource(parent);
            rc.initResource(resource);
            return resource;
        }
        return null;
    }

    @Override
    public Object getSubResource(RestResource parent)
    {
        // this method is only used for generating the API model, so no need to check the media type and path here
        if (parent instanceof RootResource && isApplicable("support_app_sf_rest_mycoupon"))
        {
            return new MyCouponListResource();
        }
        return null;
    }

}
