package com.intershop.sellside.rest.mycoupon.v1.capi.resource.mycoupon;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.core.Is.is;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

import javax.ws.rs.container.ResourceContext;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

import org.junit.Rule;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnit;
import org.mockito.junit.MockitoRule;

import com.google.inject.Injector;
import com.intershop.sellside.rest.mycoupon.v1.capi.request.mycoupon.MyCouponItemGetRequest;

/**
 * Unit test for {@link MyCouponItemResource}.
 */
public class MyCouponItemResourceTest
{
    private static final String MY_COUPON_ID = "testCouponId";

    @Rule
    public MockitoRule mockitoRule = MockitoJUnit.rule();

    @Mock
    private Injector injector;
    @Mock
    private MyCouponItemGetRequest countryItemGetRequest;
    @Mock
    private ResourceContext resourceContext;
    @Mock
    private UriInfo uriInfo;

    @InjectMocks
    private MyCouponItemResource countryItemResource = new MyCouponItemResource(MY_COUPON_ID);

    @Test
    public void testGetMyCoupon_V1()
    {
        Response expectedResponse = mock(Response.class);
        when(countryItemGetRequest.invoke(uriInfo, MY_COUPON_ID)).thenReturn(expectedResponse);

        Response actualResponse = countryItemResource.getMyCoupon_V1();

        assertThat(actualResponse, is(expectedResponse));
    }
}
