package com.intershop.sellside.rest.mycoupon.v1.capi.resource.mycoupon;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.core.Is.is;
import static org.hamcrest.core.IsNull.notNullValue;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

import javax.ws.rs.container.ResourceContext;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

import org.junit.Rule;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnit;
import org.mockito.junit.MockitoRule;

import com.google.inject.Injector;
import com.intershop.sellside.rest.mycoupon.v1.capi.request.mycoupon.MyCouponListGetRequest;

/**
 * Unit test for {@link MyCouponListResource}.
 */
public class MyCouponListResourceTest
{
    private static final String MY_COUPON_ID = "testCouponId";

    @Rule
    public MockitoRule mockitoRule = MockitoJUnit.rule();

    @Mock
    private Injector injector;
    @Mock
    private MyCouponListGetRequest myCouponListGetRequest;
    @Mock
    private ResourceContext resourceContext;
    @Mock
    private UriInfo uriInfo;

    @InjectMocks
    private MyCouponListResource myCouponListResource = new MyCouponListResource();

    @Test
    public void testGetMyCoupons_V1()
    {
        Response expectedResponse = mock(Response.class);
        when(myCouponListGetRequest.invoke(uriInfo)).thenReturn(expectedResponse);

        Response actualResponse = myCouponListResource.getAllMyCoupons_V1();

        assertThat(actualResponse, is(expectedResponse));
    }

    @Test
    public void testGetCountryItemResource()
    {
        MyCouponItemResource myCouponItemResource = myCouponListResource.getMyCouponItemResource(MY_COUPON_ID);

        assertThat(myCouponItemResource, notNullValue());
        verify(resourceContext).initResource(myCouponItemResource);
        verify(injector).injectMembers(myCouponItemResource);
    }
}
